program Project1;

const
  WGM01 = 1;
  CS01 = 1;

  procedure mysleep(t: int32);
  var
    i: Int32;
  begin
    for i := 0 to t do begin
      asm
               Nop;
      end;
    end;
  end;

  procedure sei; assembler;
  asm
           Sei
  end;

  procedure cli; assembler;
  asm
           Cli
  end;

const
  blank = 16;
  minus = 17;

  // PortB
  dataInPin = 0;
  carryPin = 1;
  negPin = 2;
  hexPin = 3;

  // PortD
  dataOutPin = 0;
  latchPin = 1;
  clockPin = 2;

const
  digits: packed array[0..17] of byte = (
    %00111111, // = 0
    %00110000, // = 1
    %10011011, // = 2
    %10111001, // = 3
    %10110100, // = 4
    %10101101, // = 5
    %10101111, // = 6
    %00111000, // = 7
    %10111111, // = 8
    %10111101, // = 9

    %10110111, // = a
    %10111100, // = b
    %10111001, // = c
    %10011110, // = d
    %10111001, // = e
    %10110001, // = f
    %00000000, // = blank
    %10000000  // = -
    );

  procedure dw(port: byte; on: boolean);
  begin
    if on then begin
      PORTD := PORTD or (1 shl port);
    end else begin
      PORTD := PORTD and not (1 shl port);
    end;
  end;

  function dr(bit: byte): byte;
  begin
    if PINB and (1 shl bit) > 0 then begin
      Result := 1;
    end else begin
      Result := 0;
    end;
  end;


  function ShiftIn74HC165(daPin, clPin: byte): byte;
  var
    Data: byte = 0;
    i: byte;
  begin
    mysleep(20);
    for i := 0 to 7 do begin
      Data := (Data shl 1) or dr(daPin);

      dw(clPin, True);
      mysleep(20);
      dw(clPin, False);
      mysleep(20);
    end;

    Result := Data;
  end;

  procedure shiftOut595(val: byte);
  var
    i: byte;
  begin
    for i := 7 downto 0 do begin

      if (val and (1 shl i)) > 0 then begin
        dw(dataOutPin, True);
      end else begin
        dw(dataOutPin, False);
      end;

      dw(clockPin, True);
      dw(clockPin, False);
    end;
  end;

var
  zahl: array[0..3] of byte;

  procedure Timer0_Interrupt; public Name 'TIMER0_COMPA_ISR'; interrupt;
  var
    d: integer;
  const
    p: byte = 0;
  begin
    p := p + 1;
    if (p > 3) then begin
      p := 0;
    end;

    dw(latchPin, False);
    dw(latchPin, True);

    d := ShiftIn74HC165(dataInPin, clockPin);
    if dr(negPin) > 0 then begin
      if not dr(carryPin) > 0 then begin
        d -= 256;
        d := abs(d);
        zahl[0] := minus;
      end else begin
        zahl[0] := blank;
      end;

    end else begin
      zahl[0] := blank;
      if dr(carryPin) > 0 then begin
        d += 256;
      end;
    end;


    //    zahl[1] := 1;
    //    zahl[2] := 2;
    //    zahl[3] := 3;

    zahl[1] := d div 100;
    zahl[2] := d mod 100 div 10;
    zahl[3] := d mod 10;

    shiftOut595(digits[zahl[p]]);
    shiftOut595(1 shl p);
  end;

begin
  cli();
  DDRB := 0;
  DDRD := (1 shl dataOutPin) or (1 shl latchPin) or (1 shl clockPin);

  zahl[0] := blank;

  // -- Timer initialisieren
  TCCR0A := (1 shl WGM01);
  TCCR0B := TCCR0B or %101;
  TIMSK := TIMSK or (1 shl OCIE0A);
  sei();
  // --- Ende timer
  repeat
  until 1 = 2;
end.
